;
; push	n
; push	a
; push	x
; call	_xamodn
;
; (call xamodn,x,a,n)
;
; szybki algorytm potegowania modularnego
; algorytm wyznaczania wyrazenia w=x^a (mod n)
;
; na wejsciu:
; x - wartosc liczbowa
; a - wartosc liczbowa
; n - wartosc liczbowa
;
; na wyjsciu:
; eax - zadany wynik
;
; modyfikowane rejestry:
; brak
;
; shield/UnderPl
;asmpak

.data
buffx	db 32 dup (0)
.code
_xamodn proc uses ebx ecx edx esi edi,x:dword,a:dword,n:dword

	sub	ecx,ecx
	mov	esi,offset buffx
	mov	ebx,a

_xamodn_1:
	test	ebx,ebx
	jz	_xamodn_2
	sub	edx,edx
	shr	ebx,1
	rcl	edx,1
	mov	byte ptr[esi+ecx],dl
	inc	ecx
	jmp	_xamodn_1

_xamodn_2:
	sub	eax,eax
	inc	eax
	mov	ebx,x
	mov	edi,n

_xamodn_3:
	sub	edx,edx
	mul	eax
	div	edi
	mov	eax,edx
	mov	dl,byte ptr[esi+ecx-1]
	test	dl,dl
	jz	_xamodn_4
	sub	edx,edx
	mul	ebx
	div	edi
	mov	eax,edx

_xamodn_4:
	dec	ecx
	jnz	_xamodn_3
	ret

_xamodn endp